#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>

 void vsmSetMpiComm(MPI_Comm com);

#ifdef USE_GFORT
 void __vismo_MOD_vismo__init4c(int *, int *, char * );
#ifdef FLOATDATA
 void __vismo_MOD_vismo__addscalars(float *, int*, int*, int *);
 void __vismo_MOD_vismo__addscalarv(float *, int*);
 void __vismo_MOD_vismo__addvectors(float *, float *, float *, int*, int*, int *);
 void __vismo_MOD_vismo__addvectorv(float *, float *, float *, int*);
#else
 void __vismo_MOD_vismo__addscalars(double *, int*, int*, int *);
 void __vismo_MOD_vismo__addscalarv(double *, int*);
 void __vismo_MOD_vismo__addvectors(double *, double *, double *, int*, int*, int *);
 void __vismo_MOD_vismo__addvectorv(double *, double *, double *, int*);
#endif
 void __vismo_MOD_vismo__initcoords4c(int *, double *);
 void __vismo_MOD_vismo__setunicoordron(int*, double*, double*);
 void __vismo_MOD_vismo__setlocalunicoordron(int*, int *, int*, double*, double*);
 void __vismo_MOD_vismo__setunicoordroff(int*, double*, double*);
 void __vismo_MOD_vismo__setlocalunicoordroff(int*, int *, int*, double*, double*);

 void __vismo_MOD_vismo__preparevis();
 void __vismo_MOD_vismo__visualization4c(int *);
 void __vismo_MOD_vismo__visualization4cv(int *, int*);
 void __vismo_MOD_vismo__finalize();

void vismo__init(MPI_Comm comm, int rank, int psize, char *file){
vsmSetMpiComm(comm);
__vismo_MOD_vismo__init4c(&rank, &psize, file);
}

#ifdef FLOATDATA
void  vismo__addscalars(float *s, int xs, int ys, int zs){
__vismo_MOD_vismo__addscalars(s, &xs, &ys, &zs);
}

void  vismo__addscalarv(float *s, int *xs){
__vismo_MOD_vismo__addscalarv(s,xs);
}

void  vismo__addvectors(float *vx, float *vy, float *vz, int xs, int ys, int zs){
__vismo_MOD_vismo__addvectors(vx, vy, vz, &xs, &ys, &zs);
}

void  vismo__addvectorv(float *vx, float *vy, float *vz, int *xs){
__vismo_MOD_vismo__addvectorv(vx, vy, vz, xs);
}

#else
void  vismo__addscalars(double *s, int xs, int ys, int zs){
__vismo_MOD_vismo__addscalars(s, &xs, &ys, &zs);
}

void  vismo__addscalarv(double *s, int *xs){
__vismo_MOD_vismo__addscalarv(s,xs);
}

void  vismo__addvectors(double *vx, double *vy, double *vz, int xs, int ys, int zs){
__vismo_MOD_vismo__addvectors(vx, vy, vz, &xs, &ys, &zs);
}

void  vismo__addvectorv(double *vx, double *vy, double *vz, int *xs){
__vismo_MOD_vismo__addvectorv(vx, vy, vz, xs);
}


#endif
void vismo__initcoords(int yy, double *rad){
  __vismo_MOD_vismo__initcoords4c(&yy, rad);
}

void vismo__setunicoord(int *n, double *corner, double *dx, int raddeg){
   if(raddeg == 0){
   __vismo_MOD_vismo__setunicoordron(n, corner, dx);
   } else if (raddeg == 1){
   __vismo_MOD_vismo__setunicoordroff(n, corner, dx);
   } else {
       printf("radian or degree??\n");
       exit(1);
   }
}

void vismo__setlocalunicoord(int *n, int *lx, int*ln, double *corner, double *dx, int raddeg){
   if(raddeg == 0){
   __vismo_MOD_vismo__setlocalunicoordron(n, lx, ln, corner, dx);
   } else if (raddeg == 1){
   __vismo_MOD_vismo__setlocalunicoordroff(n, lx, ln, corner, dx);
   } else {
       printf("radian or degree??\n");
       exit(1);
   }
}

void vismo__preparevis(){
  __vismo_MOD_vismo__preparevis();
}

void vismo__visualization(int step){
  __vismo_MOD_vismo__visualization4c(&step);
}

void vismo__visualizationv(int step, int *vex){
  __vismo_MOD_vismo__visualization4cv(&step, vex);
}

void vismo__finalize(){
  __vismo_MOD_vismo__finalize();
}

#endif

#ifdef USE_IFORT
 void vismo_mp_vismo__init4c_(int*, int*, char * );
#ifdef FLOADDATA
 void vismo_mp_vismo__addscalars_(float *, int*, int*, int *);
 void vismo_mp_vismo__addscalarv_(float *, int*);
 void vismo_mp_vismo__addvectors_(float *, float *, float *, int*, int*, int *);
 void vismo_mp_vismo__addvectorv_(float *, float *, float *, int*);
#else
 void vismo_mp_vismo__addscalars_(double *, int*, int*, int *);
 void vismo_mp_vismo__addscalarv_(double *, int*);
 void vismo_mp_vismo__addvectors_(double *, double *, double *, int*, int*, int *);
 void vismo_mp_vismo__addvectorv_(double *, double *, double *, int*);
#endif
 void vismo_mp_vismo__initcoords4c_(int *, double *);
 void vismo_mp_vismo__setunicoordron_(int*, double*, double*);
 void vismo_mp_vismo__setunicoordroff_(int*, double*, double*);
 void vismo_mp_vismo__setlocalunicoordron_(int*, int *, int*, double*, double*);
 void vismo_mp_vismo__setlocalunicoordroff_(int*, int *, int*, double*, double*);
 void vismo_mp_vismo__preparevis_();
 void vismo_mp_vismo__visualization4c_(int *);
 void vismo_mp_vismo__visualization4cv_(int *, int *);
 void vismo_mp_vismo__finalize_();

void vismo__init(MPI_Comm, int rank, int psize, char *file){
vsmSetMpiComm(comm);
vismo_mp_vismo__init4c_(&rank, &psize, file);
}

#ifdef FLOATDATA
void  vismo__addscalars(float *s, int xs, int ys, int zs){
vismo_mp_vismo__addscalars_(s, &xs, &ys, &zs);
}

void  vismo__addscalarv(float *s, int *xs){
vismo_mp_vismo__addscalarv_(s,xs);
}

void  vismo__addvectors(float *vx, float *vy, float *vz, int xs, int ys, int zs){
vismo_mp_vismo__addvectors_(vx, vy, vz, &xs, &ys, &zs);
}

void  vismo__addvectorv(float *vx, float *vy, float *vz, int *xs){
vismo_mp_vismo__addvectorv_(vx, vy, vz, xs);
}

#else
void  vismo__addscalars(double *s, int xs, int ys, int zs){
vismo_mp_vismo__addscalars_(s,&xs,&ys,&zs);
}

void  vismo__addscalarv(double *s, int *xs){
vismo_mp_vismo__addscalarv_(s,xs);
}

void  vismo__addvectors(double *vx, double *vy, double *vz, int xs, int ys, int zs){
vismo_mp_vismo__addvectors_(vx, vy, vz, &xs, &ys, &zs);
}

void  vismo__addvectorv(double *vx, double *vy, double *vz, int *xs){
vismo_mp_vismo__addvectorv_(vx, vy, vz, xs);
}

#endif
void vismo__initcoords(int yy, double *rad){
  vismo_mp_vismo__initcoords4c_(&yy, rad);
}

void vismo__setunicoord(int *n, double *corner, double *dx, int raddeg){
   if(raddeg == 0){
   vismo_mp_vismo__setunicoordron_(n, corner, dx);
   } else if (raddeg == 1){
   vismo_mp_vismo__setunicoordroff_(n, corner, dx);
   } else {
       printf("radian or degree??\n");
       exit(1);
   }
}

void vismo__setlocalunicoord(int *n, int *lx, int*ln, double *corner, double *dx, int raddeg){
   if(raddeg == 0){
     vismo_mp_vismo__setlocalunicoordron_(n, lx, ln, corner, dx);
   } else if (raddeg ==1){
   vismo_mp_vismo__setlocalunicoordroff_(n, lx, ln, corner, dx);
  } else {
       printf("radian or degree??\n");
       exit(1);
   }
}

void vismo__preparevis(){
  vismo_mp_vismo__preparevis_();
}

void vismo__visualization(int step){
  vismo_mp_vismo__visualization4c_(&step);
}

void vismo__visualizationv(int step, int *vex){
  vismo_mp_vismo__visualization4cv_(&step, vex);
}

void vismo__finalize(){
  vismo_mp_vismo__finalize_();
}


#endif
