#include <mpi.h>

static MPI_Comm vismo__comm; 

void vsmSetMpiComm(MPI_Comm com){
/*  printf("mpi com set\n");*/
  vismo__comm = com;
}

void vsmmpibcastint_(int *buf, int *num, int *root){
/*  printf("int num=%d, root=%d\n",*num,*root);*/
  MPI_Bcast(buf,  *num, MPI_INT, *root, vismo__comm);
}

void vsmmpibcastfloat_(float *buf, int *num, int *root){
/*  printf("float num=%d, root=%d\n",*num,*root);*/
  MPI_Bcast(buf,  *num, MPI_FLOAT, *root, vismo__comm);
}

void vsmmpibcastdble_(double *buf, int *num, int *root){
/*  printf("dble num=%d, root=%d\n",*num,*root);*/
  MPI_Bcast(buf,  *num, MPI_DOUBLE, *root, vismo__comm);
}

void vsmmpiallreduceintmin_(int *sbuf, int *rbuf, int *num){
  MPI_Allreduce(sbuf, rbuf, *num, MPI_INT, MPI_MIN, vismo__comm);
}

void vsmmpiallreducedblemin_(double *sbuf, double *rbuf, int *num){
  MPI_Allreduce(sbuf, rbuf, *num, MPI_DOUBLE, MPI_MIN, vismo__comm);
}

void vsmmpisendint_(int *buf, int *num, int *dest){
  int tag = 0;
  MPI_Send(buf,  *num, MPI_INT, *dest, tag, vismo__comm);
}

void vsmmpisendfloat_(float *buf, int *num, int *dest){
  int tag = 0;
  MPI_Send(buf,  *num, MPI_FLOAT, *dest, tag, vismo__comm);
}

void vsmmpirecvint_(int *buf, int *num, int *source){
  MPI_Status status;
  int tag = 0;
  MPI_Recv(buf,  *num, MPI_INT, *source, tag, vismo__comm, &status);
}

void vsmmpirecvfloat_(float *buf, int *num, int *source){
  MPI_Status status;
  int tag = 0;
  MPI_Recv(buf,  *num, MPI_FLOAT, *source, tag, vismo__comm, &status);
}

void vsmmpibarrier_(){
  MPI_Barrier(vismo__comm);
}

void vsmmpiabort_(int *ecode){
  MPI_Abort(vismo__comm, *ecode);
}
