#include <stdio.h>
#include <stdlib.h>
#include <png.h>

#define MAX_HEIGHT 10000
#define MAX_FILENAME 513

void vsmwritepng_ (char *file, int *flen, int *width, int *height, char *limage)
{
  FILE *fp;

  int i;
  char filename[MAX_FILENAME];
  unsigned char *image[MAX_HEIGHT];
  png_structp pngsp;
  png_infop pnginfp;

  if(*height > MAX_HEIGHT){
    printf("OutputPNGImage: image height exceeds %d\n",MAX_HEIGHT);
    exit(1);
  }

  if(*flen > MAX_FILENAME-1){
    printf("OutputPNGImage: filename too long. less than %d characters\n",MAX_FILENAME);
    exit(1);
  }

  for(i=0;i< *flen;i++){
    filename[i] = file[i];
  }

  filename[*flen]   ='\0';

  for(i=0;i<*height;i++){
    image[i] = (unsigned char*)&limage[i*(*width)*3];
  }

  pngsp = png_create_write_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);

  if(pngsp == NULL){
    puts("png_create_write_struct failed");
    exit(1);
  }

  pnginfp = png_create_info_struct(pngsp);

  if (pnginfp == NULL){
    puts("png_create_info_struct failed");
    exit(1);
  }

  if ((fp=fopen(filename, "wb"))==NULL){
    puts("File Open for png failed");
    exit(1);
  }

  if(setjmp(png_jmpbuf(pngsp))){
    fclose(fp);
    printf("PNG failed\n");
    exit(1);
  }

  png_init_io(pngsp, fp);

  png_set_IHDR(pngsp, pnginfp, *width, *height, 8, PNG_COLOR_TYPE_RGB,
      PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);

  png_write_info(pngsp, pnginfp);
  png_write_image(pngsp, image);
  png_write_end(pngsp, pnginfp);

  png_destroy_write_struct(&pngsp, &pnginfp);

  fclose(fp);

  return;
}

