#ifndef __VISMO4C_H__
#define __VISMO4C_H__

#include <mpi.h>

/*For gfortran+gcc and ifort + icc 
#define USE_GFORT
*/

void vismo__init(MPI_Comm comm, int rank, int psize, char *file);

#ifdef FLOATDATA
void  vismo__addscalars(float *s, int xs, int ys, int zs);
void  vismo__addscalarv(float *s, int *xs);
void  vismo__addvectors(float *vx, float *vy, float *vz, int xs, int ys, int zs);
void  vismo__addvectorv(float *vx, float *vy, float *vz, int *xs);

#else
void  vismo__addscalars(double *s, int xs, int ys, int zs);
void  vismo__addscalarv(double *s, int *xs);
void  vismo__addvectors(double *vx, double *vy, double *vz, int xs, int ys, int zs);
void  vismo__addvectorv(double *vx, double *vy, double *vz, int *xs);
#endif

void vismo__initcoords(int yy, double *rad);
void vismo__setunicoord(int *n, double *corner, double *dx, int radian);
void vismo__setlocalunicoord(int *n, int *lx, int*ln, double *corner, double *dx, int radian);
void vismo__preparevis();
void vismo__visualization(int step);
void vismo__visualizationv(int step, int *vex);
void vismo__finalize();

const int vismo__Yin = 0;
const int vismo__Yang = 1;

const int vismo__Radian = 1;
const int vismo__Degree = 0;

#endif
